;| c:XTA:AnAus

Kleine Addon, dass die Kerzen des Weihnachtsbaums aus Xmastree.lsp
lscht, bzw. wiederanzndet.

Dez. 2006
www.CADmaro.de
|;
(defun XmasTree-Addon:AnAus (/ kerzen)
  (vl-load-com)
  (if
    (setq kerzen
           (cond
             ((ssget "X" '((0 . "3DFACE") (62 . 2))))
             ('T nil)
           )
    )
     (mapcar
       '(lambda (arg / obj)
          (setq obj (vlax-ename->vla-object arg))
          (if
            (= :vlax-false (vlax-get-property obj 'Visible))
             (vlax-put-property obj 'Visible :vlax-true)
             (vlax-put-property obj 'Visible :vlax-false)
          )
        )
       (mx:SelectionSet->EList kerzen)
     )
     (alert "Keine Kerzen gefunden. Trotzdem: Frohe Weihnachten!"
     )
  )
)


(defun mx:SelectionSet->EList (ss / c lst)
  (repeat (setq c (sslength ss))
    (setq lst
           (cons
             (ssname ss (setq c (1- c)))
             lst
           )
    )
  )
  lst
)

(defun c:XTA:AnAus (/ echo)
  (setq echo (getvar "CMDECHO"))
  (setvar "CMDECHO" 0)
  (command "_shademode" "_g")
  (XmasTree-Addon:AnAus)
  (setvar "CMDECHO" echo)
  (princ)
)

(princ
  "\nXmastree-Addon \"AnAus\" wurde geladen. Zum Lschen, bzw. Wiederanznden der Kerzen \"XTA:AnAus\" eingeben.
Frohe Weihnachten!"
)
(princ)